﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using SFDCWebServiceExample.SFDCCustom;
using SFDCWebServiceExample.SFDC_Enterprise_WSDL;
using System.Web.Services.Protocols;

namespace SFDCWebServiceExample
{
    public partial class AddExpenditure : Form
    {
        private SforceService binding;
        private LoginResult lr;
        private SaveExpenditureWebServiceService myBinding = new SaveExpenditureWebServiceService();

        public AddExpenditure()
        {
            InitializeComponent();
        }

        private void btnExpenditure_Click(object sender, EventArgs e)
        {
            if (login())
            {
                try
                {
                    #region[Consume Custome webservice]
                    //Code 2
                    myBinding.SessionHeaderValue = new SFDCCustom.SessionHeader();
                    myBinding.SessionHeaderValue.sessionId = lr.sessionId;

                    // Update: Copy the URL returned by login to the endpoint for our web service
                    int idx1 = lr.serverUrl.IndexOf(@"/services/");
                    int idx2 = myBinding.Url.IndexOf(@"/services/");
                    if (idx1 == 0 || idx2 == 0)
                    {
                        MessageBox.Show("Invalid URL strings in bindings");
                    }

                    myBinding.Url = lr.serverUrl.Substring(0, idx1) + myBinding.Url.Substring(idx2);
                    
                    decimal amnt = 0;

                    Decimal.TryParse(txtAmount.Text,out amnt);

                    SFDCCustom.Expenditure__c c = myBinding.createExpenditure(amnt, txtExpName.Text, cboPaidBy.SelectedItem.ToString());
                    MessageBox.Show("Record Added Succesfully to salesforce");
                    #endregion
                }
                catch (Exception e1)
                {
                    MessageBox.Show(e1.Message);
                }
            }
        }

        private bool login()
        {
            try
            {
                binding = new SforceService();
                binding.Timeout = 6000;
                lr = binding.login(txtUserName.Text, txtPwd.Text);
                return true;
            }
            catch (SoapException e)
            {
                MessageBox.Show(e.Message);
            }
            return false;
        }

        private bool validateControls()
        {
            if (txtPwd.Text.Trim() == string.Empty && txtUserName.Text.Trim() == string.Empty)
            {
                MessageBox.Show("Please provide the credentials");
                return false;
            }
            return true;
        }
    }
}
