﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Web.Services.Protocols;
using SFDCWebServiceExample.SFDCCustom;
using SFDCWebServiceExample.SFDC_Enterprise_WSDL;


namespace SFDCWebServiceExample
{
    public partial class Form1 : Form
    {
        private SforceService binding;
        private LoginResult lr;
        private SaveExpenditureWebServiceService myBinding = new SaveExpenditureWebServiceService();

        public Form1()
        {
            InitializeComponent();            
        }

        private void btnLogin_Click(object sender, EventArgs e)
        {

            if (login())
            {
                describeGlobal();
            }
        }

        private bool login()
        {
            try
            {
                binding = new SforceService();
                binding.Timeout = 6000;
                lr = binding.login(txtUserName.Text, txtPwd.Text);
                return true;
            }
            catch (SoapException e)
            {
                MessageBox.Show(e.Message);
            }
            return false;
        }
        private void describeGlobal()
        {
            binding.Url = lr.serverUrl;
            #region[Consume Enterprise webservice]
           
            binding.SessionHeaderValue = new SFDC_Enterprise_WSDL.SessionHeader();
            binding.SessionHeaderValue.sessionId = lr.sessionId;
            #endregion

            //describeGlobal returns an array of object results that
            //includes the object names that are available to the logged-in user

            DescribeGlobalResult dgr = binding.describeGlobal();

            //Loop through the array echoing the object names to the console 
            StringBuilder sb = new StringBuilder();
            for (int i = 0; i < dgr.sobjects.Length; i++)
            {
                sb.Append(dgr.sobjects[i].name+" , ");
            }
            MessageBox.Show(sb.ToString());
        }
   }
}
